------------------------------------------------------------------------
-- |
-- Module      :  ALife.Creatur.Wain
-- Copyright   :  (c) Amy de Buitléir 2012-2015
-- License     :  BSD-style
-- Maintainer  :  amy@nualeargais.ie
-- Stability   :  experimental
-- Portability :  portable
--
-- A data mining agent, designed for the Créatúr framework.
--
------------------------------------------------------------------------
module ALife.Creatur.Wain
  (
    -- * Constructors
    Wain(..),
    Label,
    buildWainAndGenerateGenome,
    Condition,
    -- * Lenses
    name,
    appearance,
    brain,
    devotion,
    ageOfMaturity,
    passionDelta,
    energy,
    passion,
    boredom,
    age,
    litter,
    childrenBorneLifetime,
    childrenWeanedLifetime,
    genome,
    -- * Teaching and learning
    chooseAction,
    reflect,
    imprint,
    -- * Misc.
    adjustEnergy,
    adjustBoredom,
    autoAdjustPassion,
    autoAdjustBoredom,
    coolPassion,
    happiness,
    childEnergy,
    hasLitter,
    litterSize,
    incAge,
    condition,
    mate,
    weanMatureChildren,
    pruneDeadChildren,
    packageVersion
  ) where

import ALife.Creatur.WainInternal
import ALife.Creatur.Wain.Brain (Condition)
import ALife.Creatur.Wain.GeneticSOM (Label)
